unit SomeStuff;
interface
uses
Inifiles,Windows,Classes,SysUtils,Controls,FileCtrl,
        ShlObj,
        dialogs,
        Clipbrd;
procedure Split(const Delimiter: Char;Input: string;const Strings: TStrings);
//function CreateTempFile: TFileName;
function getAllFileList(filename:pchar):TStringlist;
function GetEnvVarValue(const VarName: string): string;
function getLastPos(charDelimiter:char;StringToAnalyse:pchar):integer;
procedure LoadData2Clip(myStr:TmemoryStream;sizeMax:int64);
implementation

procedure ScruteFichier(Dossier:string;filtre:string;attributs:integer;List:TstringList);
var FichierTrouve:string; Resultat:integer; SearchRec:TSearchRec;
begin
 if Dossier[length(Dossier)]='\' then Dossier:=copy(Dossier,1,length(Dossier)-1);
 Resultat:=FindFirst(Dossier+'\'+filtre,Attributs,SearchRec);
 while Resultat=0 do begin
  if ((SearchRec.Attr and faDirectory<=0)) then begin // On a trouv un Fichier (et non un dossier)
   FichierTrouve:=Dossier+'\'+SearchRec.Name;
   List.Add(FichierTrouve);
  end;
  Resultat:=FindNext(SearchRec);
 end;
 FindClose(SearchRec);// libration de la mmoire
end;

procedure ScruteDossier(Dossier:string;filtre:string;attributs:integer;recursif:boolean;List:TstringList);
var DossierTrouve:string; Resultat:integer; SearchRec:TSearchRec; begin
if Dossier[length(Dossier)]='\' then Dossier:=copy(Dossier,1,length(Dossier)-1);
ScruteFichier(Dossier,filtre,attributs,List);
if recursif then begin                                       
 Resultat:=FindFirst(Dossier+'\'+'*.*',FaDirectory,SearchRec);
 while Resultat=0 do begin
  if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') and ((SearchRec.Attr and faDirectory)>0)then begin//Dossier seulement
   DossierTrouve:=Dossier+'\'+SearchRec.Name; // pour avoir le nom du dossier avec le chemin complet
   if recursif then begin
    List.Add(DossierTrouve+'\');
    ScruteDossier(DossierTrouve,filtre,attributs,recursif,List);
   end;
  end;
  Resultat:=FindNext(SearchRec);
 end;
end;//fin de if rcursif
FindClose(SearchRec);// libration de la mmoire
end;

function GetEnvVarValue(const VarName: string): string;
var
  BufSize: Integer;  // buffer size required for value
begin
  // Get required buffer size (inc. terminal #0)
  BufSize := GetEnvironmentVariable(PChar(VarName), nil, 0);
  if BufSize > 0 then
  begin
    // Read env var value into result string
    SetLength(Result, BufSize - 1);
    GetEnvironmentVariable(PChar(VarName),
    PChar(Result), BufSize);
  end
  else
    // No such environment variable
    Result := '';
end;

procedure LoadData2Clip(myStr:TmemoryStream;sizeMax:int64);
var
outbuf:pchar;
i:integer;
nb:cardinal;
begin
nb:=sizeof(char);
outbuf:=StrAlloc(sizeMax*nb);
for i:=0 to sizeMax-2 do myStr.Read(outbuf[i],nb);
Clipboard.SetTextBuf(pchar(''));
Clipboard.SetTextBuf(outbuf);
StrDispose(outbuf);
end;
procedure Split(const Delimiter: Char;Input: string;const Strings: TStrings); begin
  Assert(Assigned(Strings));
  Strings.Clear;
  Strings.Delimiter := Delimiter;
  Strings.DelimitedText := Input;
end;

function getAllFileList(filename:pchar):TStringlist;
var Txtfile:TextFile;
Listmp,tmpList:TStringlist;
WholeL:TStringList;
Line:string;
removeSrcText,s:string;
i,j:integer;
oneChar:pchar;

begin

AssignFile(Txtfile, filename);
reset(Txtfile);
Listmp:=TStringList.Create;
//we read the file given by TC
while not Eof(TxtFile) do begin
     ReadLn(TxtFile, Line);
     if Line<>'' then begin
      Listmp.add(Line);
     end;
end;
CloseFile(Txtfile);
WholeL:=TStringList.Create;
tmpList:=TStringList.Create;
j:=Listmp.Count-1;
for i:=0 to j do begin
 oneChar:=strend(pchar(Listmp[i]))-1;
 if oneChar[0]='\' then begin
  tmpList.add(Listmp[i]);
 end
 else WholeL.Add(Listmp[i]);
end;
j:=tmpList.Count-1;
for i:=0 to j do begin
 WholeL.Add(tmpList[i]);
 ScruteDossier(tmpList[i],'*.*',faAnyFile,true,WholeL);
end;
tmpList.Free;
Listmp.Free;
{j:=WholeL.Count-1;
removeSrcText:='';
for i:=0 to j do begin
 if ((i=0)) then begin
  removeSrcText:=ExtractFilePath(WholeL[i]);
  s:=WholeL[i];
 end else s:=StringReplace(WholeL[i],removeSrcText , '',[rfReplaceAll, rfIgnoreCase]);
 WholeL[i]:=s;
end;
 }

result:=WholeL;
end;

function getLastPos(charDelimiter:char;StringToAnalyse:pchar):integer;
var i,maxSize:integer;
goOn:boolean;
oneFound:boolean;
begin
 maxSize:=StrLen(StringToAnalyse);
 i:=0;
 goOn:=true;
 oneFound:=false; 
 while ((i<=maxSize) and (goOn)) do begin
   i:=i+1;
   if StringToAnalyse[maxSize-i]=charDelimiter then begin
    if oneFound then goOn:=false;
    oneFound:=true;
   end;
 end;
 result:=maxSize-i+2;
end;

begin
end.
